<template>

  <div class="q-pa-md">
  
    <q-banner v-show="locked" inline-actions rounded class="bg-orange text-white">
      This table was set on read-only by {{ofrlexStatus.author}} on {{ofrlexStatus.date.replace(" ", " at ")}}.
    </q-banner>
    <q-banner v-show="ofrlexStatus.campaignOngoing" inline-actions rounded class="bg-purple text-white">
      Ongoing Validation Campaign id {{ofrlexStatus.campaign}} (started by {{$store.getters.getValidationCampaign.author}}) on {{$store.getters.getValidationCampaign.startDate}}.
    </q-banner>
    <q-linear-progress size="25px" :value="validationProgress" color="accent">
      <div class="absolute-full flex flex-center">
        <q-badge color="white" text-color="accent" :label="'Validation: '+validationProgressLabel" />
      </div>
    </q-linear-progress>

    <!-- <q-btn-group spread v-show="true">
      <q-btn v-show="isAdmin() && ofrlexStatus.campaignOngoing == false"  :disabled="selected.length<1" label="Start Validation Campaign" color="accent" @click="campaignSettingsDial = true" >
        <q-badge v-show="selected.length > 0" color="green" floating>{{selected.length}}</q-badge>  
        <q-tooltip :delay="300" content-class="bg-white text-primary">Select entries first then start an evaluation campaign</q-tooltip>
      </q-btn> 
      <q-btn v-show="ofrlexStatus.campaignOngoing" label="Reset" color="negative" @click="resetCampaign()"></q-btn>
    </q-btn-group> -->

    <q-table
      ref="ofrlexTable"
      class="my-sticky-header-table rounded-borders"
      title="Ofrlex"
      :data="items"
      :columns="fields"
      row-key="id"
      :pagination.sync="pagination"
      :loading="loading"
      loading-label="loading"
      @request="getOfrlexPageFromBackend"
      :filter="filter"
      binary-state-sort
      :visible-columns="visibleColumns"
      selection="multiple"
      :selected.sync="selected"
      dense
    >

      <template v-slot:top="props">
        <div class="row">
        <q-btn color="accent" flat text-color="accent" icon="help" @click="runTour()" >
            <q-tooltip :delay="300" content-class="bg-white text-primary">Start guide tour</q-tooltip>
        </q-btn>
        <q-btn color="info" flat text-color="info" icon="book" @click="doc.dialDoc = true" data-v-step="doc">
            <q-tooltip :delay="300" content-class="bg-white text-primary">Documentation</q-tooltip>
        </q-btn>
        <q-btn color="info" flat text-color="info" icon="history" @click="historyDial = true" data-v-step="history">
            <q-tooltip :delay="300" content-class="bg-white text-primary">History</q-tooltip>
        </q-btn>
        <q-btn-group flat data-v-step="actions">
          <!-- <q-btn flat color="default" text-color="blue-grey-8" icon="refresh" @click="refreshData()">
            <q-tooltip :delay="300" content-class="bg-white text-primary">Refresh table</q-tooltip>
          </q-btn> -->
          
          <q-btn flat color="default" text-color="blue-grey-8" icon="create" @click="dialogCrea=true" :disable="locked && !isAdmin()">
            <q-tooltip :delay="300" content-class="bg-white text-primary">Add new entry</q-tooltip>
          </q-btn>
          <q-btn flat color="default" @click="dialogUpload = true" :disable="locked && !isAdmin()">
            <q-icon name="cloud_upload" color="blue-grey-8"></q-icon>
            <q-badge color="grey-11" class="text-positive" floating transparent>
              <q-icon name="fas fa-file-excel" size="15px"></q-icon>
            </q-badge>
            <q-tooltip :delay="300" content-class="bg-white text-primary" >Import Excel File</q-tooltip>
          </q-btn>
          <q-btn-dropdown flat color="blue-grey-8" icon="archive" :loading="loadingExcel" :disable="loadingExcel" >
            <q-list>
              <q-item clickable v-close-popup @click="exportPageAsExcel()">
                <q-item-section avatar>
                  <q-avatar icon="save_alt" color="default" text-color="blue-grey-8" />
                </q-item-section>
                <q-item-section>
                  <q-item-label>Page</q-item-label>
                  <q-item-label caption>Export only the current page</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="exportCatExcels()">
                <q-item-section avatar>
                  <q-avatar icon="save" color="default" text-color="blue-grey-8" />
                </q-item-section>
                <q-item-section>
                  <q-item-label>Categories</q-item-label>
                  <q-item-label caption>Export the categories</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="exportSelectionAsExcel()" :disable="selected.length<1">
                <q-item-section avatar>
                  <q-avatar >
                    <q-icon name="fas fa-file-excel" :text-color="(selected.length<1)?'brown':'text-primary'" :color="(selected.length<1)?'default':'positive'" ></q-icon>
                    <q-badge color="grey-11" :class="(selected.length<1)?'text-default':'text-primary'" floating transparent>
                      <q-icon name="check_box" size="15px"></q-icon>
                    </q-badge>
                  </q-avatar>
                </q-item-section>
                <q-item-section>
                  <q-item-label>Selection</q-item-label>
                  <q-item-label caption>Export selected rows into an excel file</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="exportExcel()">
                <q-item-section avatar>
                  <q-avatar >
                    <q-icon name="fas fa-file-excel" text-color="positive" color="positive" ></q-icon>
                  </q-avatar>
                </q-item-section>
                <q-item-section>
                  <q-item-label>Excel OFrLex</q-item-label>
                  <q-item-label caption>Export OFrLex into an excel file</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="exportIlex()">
                <q-item-section avatar>
                  <q-avatar >
                    <q-icon name="archive" text-color="positive" color="accent" ></q-icon>
                  </q-avatar>
                </q-item-section>
                <q-item-section>
                  <q-item-label>Ilex</q-item-label>
                  <q-item-label caption>Export .ilex files (intentional lexicon)</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="exportTsv()">
                <q-item-section avatar>
                  <q-avatar >
                    <q-icon name="archive" text-color="positive" color="blue-grey-8" ></q-icon>
                  </q-avatar>
                </q-item-section>
                <q-item-section>
                  <q-item-label>TSV</q-item-label>
                  <q-item-label caption>Export .tsv files</q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-btn-dropdown>
          <q-btn v-show="selected.length<1" flat color="default" text-color="brown" icon="delete_forever" disabled>
            <q-tooltip :delay="300" content-class="bg-white text-primary">Delete selected rows</q-tooltip>
          </q-btn>
          <q-btn v-show="selected.length!=0" :loading="loadingDelete" flat color="default" text-color="red" icon="delete_forever" @click="alertDelete=true" :disable="locked && !isAdmin()">
            <q-tooltip :delay="300" content-class="bg-white text-primary">Delete selected rows</q-tooltip>
          </q-btn>
          <q-toggle v-show="isAdmin()" checked-icon="lock" unchecked-icon="lock_open" color="warning" keep-color @input="toggleFreeze()" :value="locked"> 
            <q-tooltip :delay="300" content-class="bg-white text-primary">Freeze modifications for all users</q-tooltip> 
          </q-toggle>
          <q-btn-dropdown color="primary" flat text-color="primary" icon="grading" :loading="loadingVC" :disable="loadingVC">
            <q-list>

              <q-item v-show="isAdmin() && ofrlexStatus.campaignOngoing == false" clickable v-close-popup @click="campaignSettingsDial = true" :disabled="selected.length<1">
                <q-item-section top avatar>
                  <q-avatar icon="play_circle_filled" color="default" text-color="accent" />
                </q-item-section>
                <q-item-section>
                  <q-item-label>Start Validation Campaign</q-item-label>
                  <q-item-label caption>Using the {{selected.length}} selected entries</q-item-label>
                </q-item-section>
                 <q-item-section side top>
                    <q-badge v-show="selected.length > 0" color="green" floating>{{selected.length}}</q-badge>
                  </q-item-section>
              </q-item>

              <q-item v-show="!viewCampaign" clickable v-close-popup @click="viewCampaign=true; getCampaignEntries();" :disable="!ofrlexStatus.campaignOngoing">
                <q-item-section avatar>
                  <q-avatar icon="offline_pin" color="default" text-color="green"/>
                </q-item-section>
                <q-item-section>
                  <q-item-label>Toggle View</q-item-label>
                  <q-item-label caption>View Campaign Entries only</q-item-label>
                </q-item-section>
              </q-item>



<!-- <q-btn v-show="isAdmin() && ofrlexStatus.campaignOngoing == false"  :disabled="selected.length<1" label="Start Validation Campaign" color="accent" @click="campaignSettingsDial = true" >
        <q-badge v-show="selected.length > 0" color="green" floating>{{selected.length}}</q-badge>  
        <q-tooltip :delay="300" content-class="bg-white text-primary">Select entries first then start an evaluation campaign</q-tooltip>
      </q-btn> -->



              <q-item v-show="viewCampaign" clickable v-close-popup @click="viewCampaign=false; refreshData(); " :disable="!ofrlexStatus.campaignOngoing">
                <q-item-section avatar>
                  <q-avatar icon="offline_pin" color="default" text-color="blue-grey-8" />
                </q-item-section>
                <q-item-section>
                  <q-item-label>Toggle View</q-item-label>
                  <q-item-label caption>Switch back to normal view</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="validateAll(2)" :disable="!isAdmin()">
                <q-item-section avatar>
                  <q-avatar icon="done_all" color="default" text-color="warning" />
                </q-item-section>
                <q-item-section>
                  <q-item-label>Validate All > 2</q-item-label>
                  <q-item-label caption>Validate all entries with validators >=2</q-item-label>
                </q-item-section>
              </q-item>
              <q-item clickable v-close-popup @click="validateAll(3)" :disable="!isAdmin()">
                <q-item-section avatar>
                  <q-avatar icon="done_outline" color="default" text-color="warning" />
                </q-item-section>
                <q-item-section>
                  <q-item-label>Validate All > 3</q-item-label>
                  <q-item-label caption>Validate all entries with validators >=3</q-item-label>
                </q-item-section>
              </q-item>
              <!-- <q-item clickable v-close-popup @click="freezeCampaign()" :v-show="isAdmin()">
                <q-item-section avatar>
                  <q-avatar icon="pause" color="default" text-color="blue-grey-8" />
                </q-item-section>
                <q-item-section>
                  <q-item-label>Freeze Campaign</q-item-label>
                  <q-item-label caption>Prevent further modifications for campaign entries</q-item-label>
                </q-item-section>
              </q-item> -->
              <q-item clickable v-close-popup @click="endCampaign()" v-show="isAdmin()&&ofrlexStatus.campaignOngoing" :disable="!ofrlexStatus.campaignOngoing">
                <q-item-section avatar>
                  <q-avatar icon="playlist_add_check" color="default" text-color="accent" />
                </q-item-section>
                <q-item-section>
                  <q-item-label>End Campaign</q-item-label>
                  <q-item-label caption>End and finalize campaign</q-item-label>
                </q-item-section>
              </q-item>

            </q-list>
          </q-btn-dropdown>
          <!-- <q-btn v-show="viewCampaign==false && ofrlexStatus.campaignOngoing" flat color="default" text-color="green" icon="offline_pin" @click="viewCampaign=true; getCampaignEntries();"></q-btn>
          <q-btn v-show="viewCampaign && ofrlexStatus.campaignOngoing" flat color="default" text-color="blue-grey-8" icon="offline_pin" @click="viewCampaign=false; refreshData(); "></q-btn> -->
        </q-btn-group>

        <q-space />

        <q-input  dense debounce="400" v-model="filter" placeholder="Search" text-color="blue-grey-8">
          <template v-slot:prepend>
            <q-select borderless v-model="searchType" :options="searchTypes" label="Search Type" dense options-dense />
          </template>
          <template v-slot:append>
            <q-icon name="search" />
            <q-select borderless v-model="col" :options="colsOptions" label="Search Column" dense options-dense data-v-step="search" />
          </template>
          <q-tooltip :delay="300" content-class="bg-white text-primary">Filter the data</q-tooltip>
        </q-input>
        
        <q-space />

        <q-select
          v-model="visibleColumns"
          multiple
          borderless
          dense
          options-dense
          :display-value="$q.lang.table.columns"
          emit-value
          map-options
          :options="filterFields()"
          option-value="name"
          style="min-width: 100px"
          data-v-step="columns"
        >
          <q-tooltip :delay="300" content-class="bg-white text-primary">Select visible columns</q-tooltip>
        </q-select>

        <q-btn flat round dense text-color="blue-grey-8" :icon="props.inFullscreen ? 'fullscreen_exit' : 'fullscreen'"  @click="props.toggleFullscreen"  class="q-ml-md" />
        </div>
      </template>

      <!-- <template v-slot:header="props">
        <q-tr name="id" :props="props.colMaps['id']">
          <q-th :props="props">
            <q-tooltip>hey</q-tooltip>
          </q-th>
        </q-tr>
      </template> -->

      <!-- <template v-slot:header="props">
        <q-tr :props="props">
          <q-td auto-width>
            <q-checkbox :indeterminate-value="selected.length!=0" v-model="props.selected" :disable="locked && !isAdmin()"/>
          </q-td>
          <q-th
            v-for="col in props.cols"
            :key="col.name"
            :props="props"
            class="text-bold text-primary"
          >
            {{ col.label }} ehy
            <q-tooltip :delay="300" content-class="bg-white text-primary">Freeze modifications for all users</q-tooltip> 
          </q-th>
        </q-tr>
      </template> -->

      <template v-slot:body="props">
        <q-tr :props="props">
          <q-td auto-width>
            <q-toggle dense v-model="props.selected" :disable="locked && !isAdmin()" />
          </q-td>
          <q-td key="id" :props="props">{{ props.row.id }}</q-td>
          <q-td key="validated" :props="props">
            <q-checkbox v-model="props.row.validated" v-show="isAdmin()" :disable="locked && !isAdmin()" @input="confirmValidation(props.row)"/>
            <q-icon v-show="!viewCampaign && props.row.validated" :color="(props.row.validated?'positive':'warning')" :name="(props.row.validated?'verified':'feedback')" style="font-size: 2em;"></q-icon>
          </q-td>
          <q-td key="validators" :props="props">
            <!-- <q-icon v-show="!viewCampaign && props.row.validated" :color="(props.row.validated?'positive':'warning')" :name="(props.row.validated?'verified':'feedback')" style="font-size: 2em;"></q-icon> -->
            <q-badge v-show="!viewCampaign && props.row.validators.length > 0" :color="(props.row.validators.length>1?'green':'')">{{props.row.validators.length}}</q-badge>
            <q-tooltip content-class="bg-white text-primary">Validators: {{props.row.validators.map(item => item.username)}}</q-tooltip>
            <q-btn v-show="!props.row.validated && !props.row.validators.map(item => item.username).includes($store.getters.getUserInfos.username) && viewCampaign==true " no-caps @click="validate(props.row)">Validate<q-badge :color="(props.row.validators.length>1?'green':'')">{{props.row.validators.length}}</q-badge></q-btn>
            <q-btn v-show="!props.row.validated && props.row.validators.map(item => item.username).includes($store.getters.getUserInfos.username) && viewCampaign==true " no-caps @click="validate(props.row)">Unvalidate<q-badge :color="(props.row.validators.length>2?'green':'')">{{props.row.validators.length}}</q-badge></q-btn>
          </q-td>
          <q-td key="ofrlexHeadword" :props="props" data-v-step="expand">{{ props.row.ofrlexHeadword }}
            <q-btn v-show="props.row.vFrolexList.length > 0" dense round flat color="primary" :icon="props.expand ? 'arrow_drop_up' : 'arrow_drop_down'" @click="props.expand = !props.expand" />
          </q-td>
          <q-td key="tllemma" :props="props"><basic-mask :props="props" :source="'tllemma'"></basic-mask></q-td>
          <q-td key="macroCat" :props="props">
            <span v-show="props.row.manualCat.length <= 0" >{{ parseCat(props.row.cat) }}</span>
            <span v-show="props.row.manualCat.length > 0">{{ parseCat(props.row.manualCat).replace("!", "") }}</span>
          </q-td>
          <q-td key="cat" :props="props" >{{ props.row.cat }}</q-td>
          <q-td key="manualCat" :props="props" data-v-step="edit">
            <edit-mask :props="props" manual="manualCat" auto="cat" :parentSaveData="saveData" :disable="locked && !isAdmin()"></edit-mask>
          </q-td>
          <q-td key="subCat" :props="props"> {{ props.row.subCat }} </q-td>
          <q-td key="manualSubCat" :props="props"> 
            <edit-mask :props="props" manual="manualSubCat" auto="subCat" :parentSaveData="saveData" :disable="locked && !isAdmin()"></edit-mask>
          </q-td>
          <q-td key="inflclass" :props="props">{{ props.row.inflclass }}</q-td>
          <q-td key="manualInflclass" :props="props">
            <edit-mask :props="props" manual="manualInflclass" auto="inflclass" :parentSaveData="saveData" :disable="locked && !isAdmin()"></edit-mask>
          </q-td>
          <q-td key="syntInfo" :props="props">{{ props.row.syntInfo }}</q-td>
          <q-td key="manualSyntfeats" :props="props">
            <edit-mask :props="props" manual="manualSyntfeats" auto="syntInfo" :parentSaveData="saveData" :disable="locked && !isAdmin()"></edit-mask>
          </q-td>
          <q-td key="redistributions" :props="props">{{ props.row.redistributions }}</q-td>
          <q-td key="manualRedistributions" :props="props">
            <edit-mask :props="props" manual="manualRedistributions" auto="redistributions" :parentSaveData="saveData" :disable="locked && !isAdmin()"></edit-mask>
          </q-td>
          <q-td key="tlvariantOf" :props="props">{{ props.row.tlvariantOf }}</q-td>
          <q-td key="variantOf" :props="props">{{ props.row.variantOf }}</q-td>
          <q-td key="manualVariantOf" :props="props" class="clickable">
            <edit-variant-mask :props="props" manual="manualVariantOf" auto="variantOf" auto2="tlvariantOf" :parentSaveData="saveData" :disable="locked && !isAdmin()"></edit-variant-mask>
          </q-td>
          <q-td key="pseudosyns" :props="props"> <pseudosyns-widget  :props="props" :parentSaveData="saveData"> </pseudosyns-widget> </q-td>
          <q-td key="pseudoGlosses" :props="props">{{ props.row.pseudoGlosses }}</q-td>
          <q-td key="glossFr" :props="props">{{ props.row.glossFr }}</q-td>
          <q-td key="descendent" :props="props">{{ props.row.descendent }}</q-td>
          <q-td key="glossHierarchy" :props="props">
            <q-breadcrumbs class="text-black" active-color="text-black">
              <template v-slot:separator>
                <q-icon size="1.5em" name="chevron_right" color="primary" />
              </template>
              <q-breadcrumbs-el :label="'PG: '+props.row.pseudoGlosses" />
              <q-breadcrumbs-el :label="'FG: '+props.row.glossFr" />
              <q-breadcrumbs-el :label="'D: '+props.row.descendent"  />
            </q-breadcrumbs>
          </q-td>
        </q-tr>

        <q-tr v-show="props.expand" :props="props">
          <q-td colspan="100%">
            <!-- <div class="text-left">This is expand slot for row above: {{ props.row.ofrlexHeadword }}.</div> -->
            <div class="q-pa-md">
              <div class="row">
                <div class="col">
                <q-table flat wrap-cells card-class="bg-white text-brown" dense :data="props.row.vFrolexList" :columns="[{name:'form', label:'form', field:'form'}, {name:'lemma', label:'lemma', field:'lemma'}, {name:'cat', label:'cat', field:'msdCattexConv'}]" row-key="name" >
                  <template v-slot:top="props"><q-chip dense>Variants from Frolex</q-chip></template>
                </q-table>
                </div>
                <div class="col">
                <q-table flat wrap-cells card-class="bg-white text-brown" dense :data="props.row.vGodefroyList" :columns="[{name:'form', label:'form', field:'form'}, {name:'lemma', label:'lemma', field:'lemmaVariation'}, {name:'cat', label:'cat', field:'pos2'}]" row-key="name" >
                  <template v-slot:top="props"><q-chip dense>Variants from Godefroy</q-chip></template>
                </q-table>
                </div>
              </div>
            </div>
          </q-td>
        </q-tr>
      </template>
    
    </q-table>


    <q-dialog v-model="alertDelete" persistent>
      <q-card>
        <q-card-section class="row items-center">
          <q-avatar icon="delete_forever" color="negative" text-color="white" />
          <span class="q-ml-sm">This action is irreversible. You will delete {{selected.length}} elements. Do you still wish to continue?</span>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Cancel" color="primary" v-close-popup />
          <q-btn flat label="Delete FOREVER" color="negative" icon="delete_forever" @click="deleteRows()" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>

    <q-dialog v-model="dialogCrea" transition-show="slide-up" transition-hide="slide-down" :maximized="maximizedDialogAdd">
      <q-card  style="max-width: 100vw;">
          <q-bar>
            <div class="col text-center text-weight-bold text-blue-grey-10">Create New Entry</div>
            <q-space />
            <q-btn dense flat icon="minimize" @click="maximizedDialogAdd = false" :disable="!maximizedDialogAdd">
              <q-tooltip v-if="maximizedDialogAdd" content-class="bg-white text-primary">Minimize</q-tooltip>
            </q-btn>
            <q-btn dense flat icon="crop_square" @click="maximizedDialogAdd = true" :disable="maximizedDialogAdd">
              <q-tooltip v-if="!maximizedDialogAdd" content-class="bg-white text-primary">Maximize</q-tooltip>
            </q-btn>
            <q-btn dense flat icon="close" v-close-popup>
              <q-tooltip content-class="bg-white text-primary">Close</q-tooltip>
            </q-btn>
          </q-bar>
          
        
          <q-form @submit="creaEntry()" @reset="onResetCrea()" class="q-gutter-md" dense >
            <q-card-section class="row items-center">
              <div class="q-pa-md">
                <div class="row">
                  <div class="col"><q-input filled v-model="creaForm.ofrlexHeadword" label="Headword" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']" :dense="creaFormStyle.dense"/></div>
                </div>
                <div class="row">
                  <div class="col"><q-input filled v-model="creaForm.cat" label="Cat" :dense="creaFormStyle.dense" /></div>
                  <div class="col"><q-input filled v-model="creaForm.subcat" label="SubCat" :dense="creaFormStyle.dense" /></div>
                  <div class="col"><q-input filled v-model="creaForm.inflclass" label="Flexion" :dense="creaFormStyle.dense" /></div>
                  <div class="col"><q-input filled v-model="creaForm.syntInfo" label="SyntInfo" :dense="creaFormStyle.dense" /></div>
                </div>
                <div class="row">
                  <div class="col"><q-input filled v-model="creaForm.redistributions" label="Redistributions" :dense="creaFormStyle.dense" /></div>
                  <div class="col"><q-input filled v-model="creaForm.pseudoGlosses" label="Pseudo Glosses" :dense="creaFormStyle.dense" /></div>
                  <div class="col"><q-input filled v-model="creaForm.glossFr" label="French Gloss" :dense="creaFormStyle.dense" /></div>
                  <div class="col"><q-input filled v-model="creaForm.descendent" label="Descendent" :dense="creaFormStyle.dense" /></div>
                </div>
              </div>
            </q-card-section>
            <q-card-actions align="right">
              <q-btn label="Cancel" color="primary" flat v-close-popup />
              <q-btn label="Reset" type="reset" color="primary" flat class="q-ml-sm" />
              <q-btn label="Create" type="submit" color="primary" v-close-popup/>
            </q-card-actions>
        </q-form>
      </q-card>
    </q-dialog>

    

    <q-dialog v-model="dialogUpload" persistent :maximized="maximizedToggle" transition-show="slide-up" transition-hide="slide-down" >
      <q-card class="bg-blue-grey-1 text-black">
        <q-bar>
          <q-space />

          <q-btn dense flat icon="minimize" @click="maximizedToggle = false" :disable="!maximizedToggle">
            <q-tooltip v-if="maximizedToggle" content-class="bg-white text-primary">Minimize</q-tooltip>
          </q-btn>
          <q-btn dense flat icon="crop_square" @click="maximizedToggle = true" :disable="maximizedToggle">
            <q-tooltip v-if="!maximizedToggle" content-class="bg-white text-primary">Maximize</q-tooltip>
          </q-btn>
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip content-class="bg-white text-primary">Close</q-tooltip>
          </q-btn>
        </q-bar>

        <q-card-section>
          <div class="text-h6">Drap and Drop your file below</div>
        </q-card-section>

        <q-card-section>
          <q-list>
            <q-item tag="label" v-ripple>
              <q-item-section>
                <q-item-label>Replace the whole Ofrlex?</q-item-label>
                <q-item-label caption>Everything will be erased and replaced by your excel file content</q-item-label>
              </q-item-section>
              <q-item-section avatar>
                <q-toggle v-model="overrideUpload" color="red" />
              </q-item-section>
            </q-item>

            <q-item tag="label" v-ripple>
              <q-item-section>
                <q-item-label>Delete a batch of entries?</q-item-label>
                <q-item-label caption>An excel file with one id per row</q-item-label>
              </q-item-section>
              <q-item-section avatar>
                <q-toggle v-model="deleteUpload" color="red" />
              </q-item-section>
            </q-item>
          </q-list>
          <q-uploader :url="$store.getters.getSource + '/api/ofrlex/import/excel?override=' + overrideUpload + '&delete='+ deleteUpload" color="default" label="Upload Excel" 
          flat style="max-width: 200px; max-height: 200px" @uploaded="importExcelCallback()" auto-upload
          method="POST" field-name="file" :headers="[{name:'Authorization', value: 'Bearer '+this.$cookies.get('axesstoken')}]"
          :form-fields="[{override: true}]">
          </q-uploader>
        </q-card-section>
      </q-card>
    </q-dialog>

    <q-dialog v-model="doc.dialDoc" :maximized="doc.maximizedToggle" transition-show="slide-up" transition-hide="slide-down" >
      <q-card >
        <q-bar>
          <q-space />

          <q-btn dense flat icon="minimize" @click="doc.maximizedToggle = false" :disable="!doc.maximizedToggle">
            <q-tooltip v-if="doc.maximizedToggle" content-class="bg-white text-primary">Minimize</q-tooltip>
          </q-btn>
          <q-btn dense flat icon="crop_square" @click="doc.maximizedToggle = true" :disable="doc.maximizedToggle">
            <q-tooltip v-if="!doc.maximizedToggle" content-class="bg-white text-primary">Maximize</q-tooltip>
          </q-btn>
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip content-class="bg-white text-primary">Close</q-tooltip>
          </q-btn>
        </q-bar>

        <q-card-section>
          <documentation></documentation>
        </q-card-section>
      </q-card>
      
    </q-dialog>

    <q-dialog v-model="historyDial" transition-show="fade" transition-hide="fade" full-width><history-card></history-card></q-dialog>

    <q-dialog v-model="campaignSettingsDial" transition-show="fade" transition-hide="fade" full-width><validation-campaign-settings :selectedrows="selected"></validation-campaign-settings></q-dialog>

    <q-dialog v-model="campaignDial" transition-show="fade" transition-hide="fade" full-width></q-dialog>


    <v-tour name="ofrlexModifierTour" :steps="tour.steps" :options="tour.options"></v-tour>
  </div>
</template>

<script>
import Vue from 'vue';
import { stringify } from 'querystring';
import {json2excel, excel2json} from 'js2excel';

import api from '../boot/backend-api';
import Store from '../store/index';
import EditMask from '../components/EditMask';
import BasicMask from '../components/BasicMask';
import EditVariantMask from '../components/EditVariantMask';
import PseudosynsWidget from '../components/PseudosynsWidget';
import Documentation from '../components/Documentation';
import HistoryCard from '../components/HistoryCard';
import ValidationCampaignSettings from '../components/ValidationCampaignSettings';
import VueTour from 'vue-tour';
require('vue-tour/dist/vue-tour.css');
Vue.use(VueTour);


  export default {
    components: {
      EditMask, BasicMask, VueTour, EditVariantMask, PseudosynsWidget, Documentation, HistoryCard, ValidationCampaignSettings
    },
    data() {
      return {
        requestStats: {
          backendResponse: '',
          securedApiCallSuccess: false,
          errors: null
        },
        items: [],
        fields: [
          { name: 'id', label: 'ID', sortable: true, field: 'id' },
          { name: 'validated', label: 'Validated', sortable: true, field: 'validated'},
          { name: 'validators', label: 'Validators', sortable: true, field: 'validators'},
          { name: 'ofrlexHeadword', label: 'Headword', sortable: true, field: 'ofrlexHeadword'},
          { name: 'tllemma', label: 'Lemma', sortable: true, field: 'tllemma' },
          { name: 'macroCat', label: 'Macro Cat', field: 'cat'},
          { name: 'cat', label: 'Cat', sortable: true, field: 'cat'},
          { name: 'manualCat', label: 'Cat', sortable: true, field: 'manualCat', align: 'center' },
          { name: 'subCat', label: 'Subcat', sortable: true, field: 'subCat'},
          { name: 'manualSubCat', label: 'SubCat', sortable: true, field: 'manualSubCat' },
          { name: 'inflclass', label: 'Flexion', sortable: true, field: 'inflclass' },
          { name: 'manualInflclass', label: 'Flexion', sortable: true, field: 'manualInflclass' },
          { name: 'syntInfo', label: 'Syntactic Info', sortable: true, field: 'syntInfo'},
          { name: 'manualSyntfeats', label: 'Syntactic Info', sortable: true, field: 'manualSyntfeats'},
          { name: 'redistributions', label: 'Redistributions', sortable: true, field: 'redistributions'},
          { name: 'manualRedistributions', label: 'Redistributions', sortable: true, field: 'manualRedistributions'},
          { name: 'tlvariantOf', label: 'TLVariantOf', field: 'tlvariantOf'},
          { name: 'variantOf', label: 'VariantOf', field: 'variantOf'},
          { name: 'manualVariantOf', label: 'VariantOf', field: 'manualVariantOf'},
          { name: 'pseudosyns', label: 'PseudoSyns', field: 'pseudosyns'},
          { name: 'pseudoGlosses', label: 'Pseudo Glosses', sortable: true, field: 'pseudoGlosses'},
          { name: 'glossFr', label: 'Gloss FR', sortable: true, field: 'glossFr'},
          { name: 'descendent', label: 'Descendent', sortable: true, field: 'descendent'},
          { name: 'glossHierarchy', label: 'Pseudo Glosses > French Gloss > Descendent', field: 'glossHierarchy', align: 'center'}
        ],
        visibleColumns: ['validated', 'validators','ofrlexHeadword','macroCat','manualCat','manualSubCat','manualInflclass','manualSyntfeats','manualRedistributions', 'glossHierarchy', 'manualVariantOf', 'tllemma', 'pseudosyns'],
        pagination: {
          sortBy: 'id',
          descending: false,
          page: 1,
          rowsPerPage: 10,
          rowsNumber: 1
        },
        creaForm: {
          ofrlexHeadword: '',
          manualCat: '',
          manualSubCat: '',
          manualInflclass: '',
          syntInfo: '',
          manualRedistributions: '',
          pseudoGlosses: '',
          glossFr: '',
          descendent: ''
        },
        creaFormStyle: {
          dense: true
        },
        overrideUpload: false,
        deleteUpload: false,
        loading:false,
        loadingExcel:false,
        loadingDelete:false,
        loadingVC:false,
        totalRows: 1,
        currentPage: 1,
        perPage: 15,
        pageOptions: [5, 10, 15, 20, 25, 30],
        filter: '',
        searchType: 'any',
        searchTypes: ['any', 'startwith', 'endwith', 'exact'],
        col: 'any',
        colsOptions: ['any','ofrlexHeadword', 'cat', 'inflclass', 'redistributions'],
        alerts: { 'logerror': { color: 'negative', message: 'You are not allowed to access this page. Please login!', icon: 'report_problem' },
          'saved': { color: 'positive', message: 'This page\'s data are saved', icon: 'save'},
          'error-saved': { color: 'negative', message: 'Error saving the data', icon: 'report_problem'},
          'creating-excel': { color: 'info', message: 'File creation on server. Please wait.'},
          'created-excel': { color: 'positive', message: 'File created. Downloading.'},
          'error-excel': { color: 'negative', message: 'Timeout: Failed to create the excel file. Please contact the administrator.'},
          'deleted': { color: 'positive', message: 'Selected rows were successfully deleted', icon: 'save'},
          'locked': { color: 'warning', message: 'This table is now locked for non admin users.', icon: 'lock'},
          'frozen': { color: 'warning', message: 'This table is locked for non admin users.', icon: 'lock'},
          'unlocked': { color: 'info', message: 'This table is now accessible for everyone.', icon: 'lock_open'},
          'lock-error': { color: 'negative', message: 'Could not change the lock status. Please contact the maintainer.', icon: 'report_problem'},
          'overrided': { color: 'warning', message: 'Somebody overrided the lexicon using an external file', icon: 'announcement'}
        },
        selected: [],
        alertDelete: false,
        dialogCrea: false,
        dialogUpload: false, maximizedToggle: false, maximizedDialogAdd: false,
        locked: false,
        ofrlexStatus: {target:'', locked: false, author:'', date:'', campaignOngoing: false, campaign: null, total: null, progress: null},
        statusTimer: '',
        dataTimer: '',
        subscription: null,
        cats: ['VER', 'PROpos', 'PREFIX', 'DETpos', 'ADJint', 'DETrel_o', 'PRE', 'PROimp', 'INT', 'ADJind', 'ADVint', 'DETint', 'PROrel', 'DETcar', 'ponctw', 'PROint', 'PROdem', 'CONsub', 'PROrel_o', 'DETndf', 'NOMpro', 'parentf', 'PROper_refl', 'CONsub_o', 'PROcar', 'NOMcom', 'PROper', 'ADVneg', 'PROind', 'DETrel', 'ADJcar', 'ADJpos', 'ADJqua', 'ADJdem', 'ADVrel', 'CONsub_pre', 'DETdef', 'poncts', 'PROrel_adv', 'DETind', 'ADVgen', 'parento', 'CONcoo', 'epsilon', 'ADJord', 'DETdem'],
        // cats: ['NOMcom']
        doc: {
          dialDoc: false,
          maximizedToggle: false,
          toc: false,
          source: ''
        },
        tour: {
          steps: [
            {
              target: '[data-v-step="doc"]',
              content: 'Display the documentation.',
              params: {
                placement: 'right'
              }
            },
            {
              target: '[data-v-step="actions"]',
              content: 'Select an action.',
              params: {
                placement: 'right'
              }
            },
            {
              target: '[data-v-step="search"]',
              content: 'You can expand a row.',
              params: {
                placement: 'left'
              }
            },
            {
              target: '[data-v-step="columns"]',
              content: 'You can choose visible columns.',
              params: {
                placement: 'left'
              }
            },
            {
              target: '[data-v-step="expand"]',
              content: 'Click on the orange arrow to see more informations.',
              params: {
                placement: 'bottom'
              }
            },
            {
              target: '[data-v-step="edit"]',
              content: 'Click on red or green texts to edit. red = auto, green = manual. Right click on green text to revoke manual changes',
              params: {
                placement: 'bottom'
              }
            }
          ],
          options: {
            useKeyboardNavigation: true,
            labels: {
              buttonSkip: 'Skip',
              buttonPrevious: '<-',
              buttonNext: '->',
              buttonStop: 'Got it!'
            }
          }
        },
        historyDial:false,
        campaignSettingsDial:false,
        campaignDial: false,
        campaignView: false,
        viewCampaign: false
      }
    },
    computed: {
      sortOptions() {
        // Create an options list from our fields
        return this.fields
          .filter(f => f.sortable)
          .map(f => {
            return { text: f.label, value: f.key }
          })
      },
      validationProgressLabel() {
        if(this.ofrlexStatus.progress != null && this.ofrlexStatus.total != null) 
          return (this.ofrlexStatus.progress / this.ofrlexStatus.total * 100).toFixed(2) + '% ('+this.ofrlexStatus.progress+')';
        else
          return "-";
      },
      validationProgress() {
        if(this.ofrlexStatus.progress != null && this.ofrlexStatus.total != null) 
          return this.ofrlexStatus.progress / this.ofrlexStatus.total * 100;
        else
          return 0;
      }
    },
    mounted() {
      this.$q.loading.show();
      this.getOfrlexPageFromBackend({
        pagination: this.pagination,
        filter: this.filter
      });
      this.pagination.rowsNumber = this.items.length; // Set the initial number of items
      this.getOfrlexStatus();
      this.$q.loadingBar.setDefaults({skipHijack: true});
      this.subscription = this.$store.getters.getStompClient.subscribe('/topic/ofrlex', this.onOfrlexReceived);      
    },
    methods: {
      runTour(){
        this.$tours['ofrlexModifierTour'].start();
      },
      onOfrlexReceived(rawPayload) {
        var payload = JSON.parse(rawPayload.body);
        if(payload.type == 'LOCK'){
          this.ofrlexStatus = payload.dbs;
          this.locked = payload.dbs.locked;
        }else if(payload.type == 'UPDATE_SUCCESS'){
          console.log('updated by ', payload);
          if(payload.sender != this.$store.getters.getUserInfos.username){
            // console.log('updated by ', payload);
            var payloadIds = []; var itemsIds = [];
            payload.entries.map(function(d){payloadIds.push(d.id)});
            this.items.map(function(d){itemsIds.push(d.id)});
            let intersection = payloadIds.filter(x => itemsIds.includes(x));
            let tempItems = this.items;
            for(var j=0; j<payload.entries.length; j++){
              if(intersection.includes(payload.entries[j].id)){
                for(var i = 0; i<tempItems.length; i++){  
                  let tableIndex = tempItems[i]["__index"];
                  delete tempItems[i]["__index"];
                  if( (tempItems[i].id == payload.entries[j].id) && (JSON.stringify(tempItems[i]) !== JSON.stringify(payload.entries[j])) ){ 
                     console.log(JSON.stringify(payload.entries[j]), JSON.stringify(tempItems[i])); 
                     payload.entries[j]["__index"] = tableIndex;
                     // modify for each property
                     for (var prop in payload.entries[j]) {
                          if (Object.prototype.hasOwnProperty.call(payload.entries[j], prop)) {
                              this.items[i][prop] = payload.entries[j][prop];
                          }
                     }
                  } 
                }
              }
            }
          }else{ this.showNotif('top-right', 'saved'); }
        } else if(payload.type == 'UPDATE_LOCKED'){
          if(payload.sender == this.$store.getters.getUserInfos.username){
            this.showNotif('top-right', 'frozen');
            this.$refs.ofrlexTable.requestServerInteraction(this.pagination);
          }
        } 
        else if(payload.type == 'DELETE_SUCCESS') {
          if(payload.sender == this.$store.getters.getUserInfos.username){
            this.selected = [];
            this.showNotif('top-right', 'deleted');
            this.loading=false; this.loadingDelete=false;
          }
          this.$refs.ofrlexTable.requestServerInteraction(this.pagination);
        }
        else if(payload.type == 'DELETE_LOCKED') {
          if(payload.sender == this.$store.getters.getUserInfos.username){
            this.showNotif('top-right', 'frozen');
          }
        }
        else if(payload.type == 'ADD_SUCCESS'){
          if(payload.sender == this.$store.getters.getUserInfos.username){
            this.showNotif('top-right', 'saved');
            this.creaForm =  {ofrlexHeadword: '', cat: '',subCat: '', inflclass: '', syntInfo: '', redistributions: '',  pseudoGlosses: '',  glossFr: '', descendent: ''}; 
          }
          this.$refs.ofrlexTable.requestServerInteraction(this.pagination); 
        }
        else if(payload.type == 'ADD_LOCKED'){
          this.showNotif('top-right', 'frozen');
        }
        else if(payload.type == 'PAGE') {
          // console.log('items', this.items);
          this.items.splice(0, this.items.length, ...payload.entries);
          // update local pagination object
          this.pagination.page = page;
          this.pagination.rowsPerPage = rowsPerPage;
          this.pagination.sortBy = sortBy;
          this.pagination.descending = descending;
        }
        else if(payload.type == 'NOTIFY_OVERRIDED') {
          if(payload.sender == this.$store.getters.getUserInfos.username) {
            this.showNotif('top-right', 'saved');
          }else {
            this.alerts.overrided.message = payload.sender + ' overrided the lexicon!';
            this.showNotif('top-right', 'overrided');
          }
          this.$refs.ofrlexTable.requestServerInteraction(this.pagination);
        }
        else if(payload.type == 'CAMPAIGN_STARTED') {
          console.log('payload store setvc', JSON.stringify(payload.vc));
          // this.$store.dispatch('setValidationCampaign', payload.vc);
          this.$store.commit('set_validation_campaign', {vc: payload.vc});
          this.ofrlexStatus = payload.dbs;
          this.campaignSettingsDial = false;
          if(payload.sender == this.$store.getters.getUserInfos.username) {
            this.$q.notify({message:'Campaign Started Successfully', position:'top-right', color:'positive'});
          }else{
            this.$q.notify({message:'Campaign Started by '+payload.sender, position:'top-right', color:'positive'});
          }
        }
        else if(payload.type == 'CAMPAIGN_VIEW') {
          this.$store.dispatch('viewValidationCampaign', { user: this.$store.getters.getUserName});
        }
        else if(payload.type == 'CAMPAIGN_ENDED') {
          // this.$store.dispatch('setValidationCampaign', { id: null, author:null, targets: [], startDate: null, endDate:null  });
          this.$store.commit('set_validation_campaign', {vc: { id: null, author:null, targets: [], startDate: null, endDate:null  }});
          this.ofrlexStatus = payload.dbs;
          this.viewCampaign = false;
          if(payload.sender == this.$store.getters.getUserInfos.username) {
            this.$q.notify({message:'Campaign Ended Successfully', position:'top-right', color:'positive'});
          }else{
            this.$q.notify({message:'Campaign Ended by '+payload.sender, position:'top-right', color:'positive'});
          }
        }
      },
      getOfrlexStatus() {
        api.getOfrlexStatus()
        .then( response => {
          this.ofrlexStatus = response.data;
          this.locked = response.data.locked;
          if(response.data.campaignOngoing) { this.getCampaign(); }
          console.log('dbstate', response.data);
          this.$q.loading.hide();
        }).catch(error => {console.log(error); this.$q.loadingBar.setDefaults({skipHijack: false});});
      },
      updateData(row, slot){
        this.items[row.index][slot] = row.item[slot];
      },
      refreshData(){
        this.$refs.ofrlexTable.requestServerInteraction(this.pagination);
      },
      saveData(item, col){
        item.modifiedField = col;
        let listOfIds = this.items.map(item => item.id);
        let data = {entry:item, ids:listOfIds};
        this.$store.getters.getStompClient.send("/app/ofrlex.update", JSON.stringify(data), {});
      },
      deleteRows() {
        this.$store.getters.getStompClient.send('/app/ofrlex.delete', JSON.stringify(this.selected), {});
        this.loadingDelete=true;
      },
      importExcelCallback(){
        this.$store.getters.getStompClient.send('/app/ofrlex.notify', JSON.stringify({type: 'NOTIFY_OVERRIDED'}), {});
        this.dialogUpload = false;
      },
      exportPageAsExcel(){
        try {
            var data = this.items;
            json2excel({
                data,
                name: 'ofrlex',
                formateDate: 'yyyy/mm/dd'
            });
        } catch (e) {
            this.showNotif('top-right', 'error-excel');
        }
      },
      exportSelectionAsExcel(){
        this.loadingExcel=true;
        this.showNotif('top-right', 'creating-excel');
        var selectedIds = [];
        this.selected.map(function(d){selectedIds.push(d.id.toString())});
        let promise = api.exportOfrlexSelectionExcel(selectedIds)
          return promise.then(response => {
            this.showNotif('top-right', 'created-excel');
            const url = window.URL.createObjectURL(new Blob([response.data]));
            const link = document.createElement('a');
            link.href = url;
            link.setAttribute('download', 'selection_ofrlex.xlsx');
            document.body.appendChild(link);
            link.click();
            this.loadingExcel=false;
            return [];
          }).catch(error => {
            this.showNotif('top-right', 'error-excel');
            this.loadingExcel=false;
            return [];
          })
      },
      exportExcel(){
        this.$q.loadingBar.start();
        this.loadingExcel=true;
        this.showNotif('top-right', 'creating-excel')
        let promise = api.exportOfrlexExcel()
          return promise.then(response => {
            this.showNotif('top-right', 'created-excel');
            const url = window.URL.createObjectURL(new Blob([response.data]));
            const link = document.createElement('a');
            link.href = url;
            link.setAttribute('download', 'ofrlex.xlsx');
            document.body.appendChild(link);
            link.click();
            this.loadingExcel=false;
            this.$q.loadingBar.stop();
            return [];
          }).catch(error => {
            this.showNotif('top-right', 'error-excel');
            this.loadingExcel=false;
            this.$q.loadingBar.stop();
            return [];
          })
      },
      exportCatExcel(cat) {
        let promise = api.exportOfrlexCatExcel(cat)
        return promise.then(response => {
            this.showNotif('top-right', 'created-excel');
            const url = window.URL.createObjectURL(new Blob([response.data]));
            const link = document.createElement('a');
            link.href = url;
            link.setAttribute('download', 'ofrlex_'+cat+'.xlsx');
            document.body.appendChild(link);
            link.click();
            this.loadingExcel=false;
            this.$q.loadingBar.stop();
            return [];
          }).catch(error => {
            this.showNotif('top-right', 'error-excel');
            this.loadingExcel=false;
            this.$q.loadingBar.stop();
            return [];
          })
      },
      exportCatExcels(){
        // for (const cat of this.cats) {
        //   this.exportCatExcel(cat);
        // }
        this.loadingExcel = true;
        api.exportOfrlexCatsZip().then(response => {
            this.showNotif('top-right', 'created-excel');
            const url = window.URL.createObjectURL(new Blob([response.data]));
            const link = document.createElement('a');
            link.href = url;
            link.setAttribute('download', 'ofrlex_categories.zip');
            document.body.appendChild(link);
            link.click();
            this.loadingExcel=false;
            this.$q.loadingBar.stop();
            return [];
        }).catch(error => {
            this.showNotif('top-right', 'error-excel');
            this.loadingExcel=false;
            this.$q.loadingBar.stop();
            return [];
        });
      },
      exportIlex(){
        this.loadingExcel = true;
        api.exportOfrlexIlexZip().then(response => {
            this.showNotif('top-right', 'created-excel');
            const url = window.URL.createObjectURL(new Blob([response.data]));
            const link = document.createElement('a');
            link.href = url;
            link.setAttribute('download', 'ofrlex_ilex.zip');
            document.body.appendChild(link);
            link.click();
            this.loadingExcel=false;
            this.$q.loadingBar.stop();
            return [];
        }).catch(error => {
            this.showNotif('top-right', 'error-excel');
            this.loadingExcel=false;
            this.$q.loadingBar.stop();
            return [];
        });
      },
      exportTsv(){
        this.loadingExcel = true;
        api.exportOfrlexTsvZip().then(response => {
            this.showNotif('top-right', 'created-excel');
            const url = window.URL.createObjectURL(new Blob([response.data]));
            const link = document.createElement('a');
            link.href = url;
            link.setAttribute('download', 'ofrlex_tsv.zip');
            document.body.appendChild(link);
            link.click();
            this.loadingExcel=false;
            this.$q.loadingBar.stop();
            return [];
        }).catch(error => {
            this.showNotif('top-right', 'error-excel');
            this.loadingExcel=false;
            this.$q.loadingBar.stop();
            return [];
        });
      },
      getOfrlexPageFromBackend(props) {
        let { page, rowsPerPage, rowsNumber, sortBy, descending } = props.pagination;
        let filter = props.filter;
        this.loading=true;
        this.$q.loadingBar.start();
        if(filter != ''){
          let promise = api.filterOfrlex(page-1, rowsPerPage, filter, sortBy, descending, this.col, this.searchType)
          return promise.then(response => {
            let items = response.data.entries;
            this.requestStats.securedApiCallSuccess = true;
            this.pagination.rowsNumber = response.data.totalEntries;
            // clear out existing data and add new
            this.items.splice(0, this.items.length, ...items);

            // update local pagination object
            this.pagination.page = page;
            this.pagination.rowsPerPage = rowsPerPage;
            this.pagination.sortBy = sortBy;
            this.pagination.descending = descending;

            this.loading=false;
            this.$q.loadingBar.stop();
            // console.log('page filtered', response.data)
            return items || []; 
          }).catch(error => {
            this.loading=false;
            return [];
          })
        }else {
          let promise = api.getOfrlexPage(page-1, rowsPerPage, sortBy, descending)
          return promise.then(response => {
            // console.log('ofrlex = ', JSON.stringify(response.data.entries[0]));
            // for(var i = 0; i< response.data.entries.length; i++) {
            //   let d = response.data.entries[i];
            //   console.log(JSON.stringify([d.variantOf, d.tlvariantOf, d.vGodefroyList, d.vDect]));
            // }
            let items = response.data.entries;
            this.requestStats.securedApiCallSuccess = true;
            this.pagination.rowsNumber = response.data.totalEntries;
            // clear out existing data and add new
            this.items.splice(0, this.items.length, ...items);

            // update local pagination object
            this.pagination.page = page;
            this.pagination.rowsPerPage = rowsPerPage;
            this.pagination.sortBy = sortBy;
            this.pagination.descending = descending;

            // console.log('items', JSON.stringify(this.items) );

            this.loading=false;
            this.$q.loadingBar.stop();
            this.$q.loading.hide();
            return items || [];
          }).catch(error => {
            this.loading=false;
            this.$q.loadingBar.stop();
            return [];
          })
        }
      },
      getOfrlexPage(props) {
        let { page, rowsPerPage, rowsNumber, sortBy, descending } = props.pagination;
        // console.log('props', props, page, "/app."+page-1);
        let filter = props.filter;
        let msg = {};
        this.$store.getters.getStompClient.send("/app/ofrlex.pages."+(page-1)+"."+rowsPerPage+"."+sortBy+"."+descending, JSON.stringify(msg), {});
        
      },
      creaEntry() {
        this.$store.getters.getStompClient.send('/app/ofrlex.add', JSON.stringify(this.creaForm), {});
      },
      toggleFreeze(value) {
        var msg = { name: 'freezetoggle', type: 'LOCK', entries: [], sender:null, dbs:null, vc:null, pagination:null,entry:null, totalEntries:null };
        // this.$store.getters.getStompClient.send("/app/ofrlex.freezetoggle", JSON.stringify({type: 'LOCK'}), {});
        this.$store.getters.getStompClient.send("/app/ofrlex.freezetoggle", JSON.stringify({}), {});
      },
      startValidationCampaign(entries){
        console.log('start vc');
        // this.$store.getters.getStompClient.send("/app/ofrlex.startcampaign", JSON.stringify(entries), {});
        api.startCampaign(entries).then(response => {
          console.log('start campaign', response.data);
        }).catch(error => {console.log(error);});
      },
      getCampaign(){
        api.getCampaign().then(response => {
          this.$store.commit('set_validation_campaign', {vc: response.data});
        }).catch(error => { console.log('campaign', error); })
      },
      getCampaignEntries(){
        // getOfrlexPage(page-1, rowsPerPage, sortBy, descending)
        let { page, rowsPerPage, rowsNumber, sortBy, descending } = this.pagination;
        let filter = this.filter;
        let promise = api.getCampaignEntries(page-1, rowsPerPage, sortBy, descending)
          return promise.then(response => {
            console.log('ofrlex = ', JSON.stringify(response.data.entries[0]));
            let items = response.data.entries;
            this.requestStats.securedApiCallSuccess = true;
            this.pagination.rowsNumber = response.data.totalEntries;
            // clear out existing data and add new
            this.items.splice(0, this.items.length, ...items);

            // update local pagination object
            this.pagination.page = page;
            this.pagination.rowsPerPage = rowsPerPage;
            this.pagination.sortBy = sortBy;
            this.pagination.descending = descending;

            // console.log('items', JSON.stringify(this.items) );

            this.loading=false;
            this.$q.loadingBar.stop();
            this.$q.loading.hide();
            return items || [];
          }).catch(error => {
            this.loading=false;
            this.$q.loadingBar.stop();
            return [];
        })
      },
      resetCampaign(){
        api.resetCampaign().then(response => {
          console.log('campaign reseted');
          console.log(response.data);
          this.ofrlexStatus = response.data;
        }).catch(error => {
          console.log('campaign', error);
        })
      },
      validate(row){
        var entry = row;
        var userInfos = this.$store.getters.getUserInfos;
        if(entry.validators.map(item => item.username).includes(userInfos.username)){
          entry.validators = entry.validators.filter(function(value, index, arr){ return value.username != userInfos.username;});
        } else {
          entry.validators.push(this.$store.getters.getUserInfos);
        }
        this.saveData(entry,'validators');
      },
      confirmValidation(row){
        this.saveData(row,'validated');
      },
      validateAll(min){
        api.validateAll(min).then(response => {
          console.log(JSON.stringify(response.data) );
          this.refreshData();
        }).catch(error => {console.log(error)});
      },
      pauseCampaign(){

      },
      endCampaign(){
        var msg = { name: 'campaignend', type: 'CAMPAIGN_ENDED', entries: [], sender:null, dbs:null, vc:null, pagination:null,entry:null };
        this.$store.getters.getStompClient.send("/app/ofrlex.endcampaign", JSON.stringify(msg), {});
      },
      isAdmin() {
        let names = this.$store.getters.getUserInfos.roles.map(role => role.roleName);
        return names.includes('ADMIN_USER');
      },
      onResetCrea() {
        this.creaForm = { ofrlexHeadword: '', cat: '', subCat: '', inflclass: '', syntInfo: '', redistributions: '', pseudoGlosses: '', glossFr: '', descendent: '' }
      },
      showNotif (position, alert, msn) {
        const { color, textColor, multiLine, icon, message, avatar, actions } = this.alerts[alert];
        if(msn) { message = msn }
        const buttonColor = color ? 'white' : void 0;
        this.$q.notify({
          color,
          textColor,
          icon: icon,
          message,
          position,
          avatar,
          multiLine,
          actions: actions,
          timeout: 2000
        })
      },
      parseCat(txt) {
        try {
          return txt.replace(/[a-z]/g, '');
        }catch(error) {
          return txt;
        }
      },
      filterFields() {
        var tempArray = this.fields.filter(function( obj ) {
          return obj.field !== 'syntInfo' && obj.field !== 'cat' && obj.field !== 'redistributions' && obj.field !== 'subCat' && obj.field !== 'variantOf' && obj.field !== 'tlvariantOf' && obj.field !== 'inflclass' ;
        });
        return tempArray;
      }
    },
    beforeDestroy() {
      this.$q.loadingBar.setDefaults({skipHijack: false});
      this.subscription.unsubscribe({});
    }
  }
</script>

<style lang="stylus">
.my-sticky-header-table
  /* max height is important */
  .q-table__middle
    max-height 70vh

  .q-table__top,
  .q-table__bottom,
  thead tr:first-child th /* bg color is important for th; just specify one */
    background-color #eeeeee

  thead tr:first-child th
    position sticky
    top 0
    opacity 1
    z-index 1
</style>